package com.example.projekt4;

import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.navigation.fragment.NavHostFragment;

import com.example.projekt4.databinding.FragmentFirstBinding;
import com.example.waluty.ExchangeRatesTable;
import com.example.waluty.ObslugaNBP;
import com.example.waluty.Rate;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class FirstFragment extends Fragment {
    private ExecutorService watkiPobierajace = Executors.newSingleThreadExecutor(); // albo fixedThreadPool

    private FragmentFirstBinding binding;

    @Override
    public View onCreateView(
            @NonNull LayoutInflater inflater, ViewGroup container,
            Bundle savedInstanceState
    ) {
        binding = FragmentFirstBinding.inflate(inflater, container, false);
        return binding.getRoot();

    }

    public void onViewCreated(@NonNull View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        binding.buttonFirst.setOnClickListener(v ->
                NavHostFragment.findNavController(FirstFragment.this)
                        .navigate(R.id.action_FirstFragment_to_SecondFragment)
        );

        binding.buttonPobierzBiezace.setOnClickListener(v -> {
            wykonajCalePobieranie();
        });
    }

    private void wykonajCalePobieranie() {
        Log.d("Waluty", "pobieranie rozpoczęte");
        // komunikacji sieciowej nie wolno robić w wątku głównym
        watkiPobierajace.submit(() -> {
            Log.d("Waluty", "a kuku 1");
            ExchangeRatesTable table = ObslugaNBP.pobierzBiezaceKursy();
            Log.d("Waluty", "a kuku 2");
            // jednak zmiany w wyglądzie UI powinny być wykonane przez wątek główny
            this.getActivity().runOnUiThread(() -> {
                odswiezWidok(table);
            });
        });
        Log.d("Waluty", "pobieranie zlecone");
    }

    private void odswiezWidok(ExchangeRatesTable table) {
        Log.d("Waluty", "odswiezWidok");
        // gdy mamy binding, nie trzeba już find
        TextView textViewStatus = binding.textViewStatus;
        LinearLayout ll = binding.linearLayoutWaluty;
        if(table == null) {
            textViewStatus.setText(R.string.brak_danych);
        } else {
            textViewStatus.setText(table.toString());
            ll.removeAllViews();
            for(Rate rate : table.getRates()) {
                TextView textView = new TextView(this.getContext());
                textView.setText(rate.toString());
                ll.addView(textView);
            }
        }
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
        binding = null;
    }

}